<?php
namespace Teknisa\CDP\Modules\Producao\Controllers;

    use Teknisa\Libs\Util\Libraries\PHPMailer;
    use Zeedhi\Framework\DataSource\FilterCriteria;
    use Teknisa\CDP\Controllers\TeknisaCrud;
    use Zeedhi\Framework\DTO;
    use Zeedhi\Framework\DTO\Response\Error;
    use \Zeedhi\Framework\DataSource\DataSet;
    use Zeedhi\Framework\DataSource\ParameterBag;

    class Cdp01900ConsultaProdutoPorMateriaPrimaController extends TeknisaCrud {
        protected $Cdp01900ConsultaProdutoPorMateriaPrimaService;
        protected $dataSourceName = 'consulta_tipo_materia_prima';
        
        public function __construct($crudService, ParameterBag $parameterBag, $Cdp01900ConsultaProdutoPorMateriaPrimaService){
            parent::__construct($crudService, $parameterBag);
            $this->Cdp01900ConsultaProdutoPorMateriaPrimaService = $Cdp01900ConsultaProdutoPorMateriaPrimaService;
        }
        
        public function findConsulta(DTO\Request\Filter $request, DTO\Response $response) {
            try {
                $this->dataSourceName='consulta_tipo_materia_prima';
                $this->parameterBagColumns =  array("P_CDFILIAL","P_CDMATPRIMA");
                
                parent::find($request, $response);
                $dataSets = $response->getDataSets();
                
    
                
                if(!empty($dataSets)){
                    $rows = $dataSets[0]->getRows();
                    $dados = $this->Cdp01900ConsultaProdutoPorMateriaPrimaService->verificaCheck($rows);
                    $dataSet = new DataSet("consulta_tipo_materia_prima", $dados);
                    $response->setDataSets(array($dataSet));
                }
                
                
            } catch (\Exception $e) {
                $response->setError(new Error($e->getMessage(), 500));
            }
        }
        
        public function save(DTO\Request $request, DTO\Response $response) {
            $row = $request->getDataSet()->getRows()[0];
            
             $conditions = array(
                array(
                    "value" => $row["CDMATPRIMA"],
        	        "operator" => "=",
        	        "columnName" => "CDMATPRIMA"
                ),
                array(
                    "value" => $row["CDFILIAL"],
        	        "operator" => "=",
        	        "columnName" => "CDFILIAL"
                )
            );
            $filterCriteria = new FilterCriteria('parprodopcons', $conditions);
            $this->crudService->find($response, $filterCriteria);
            if($response->getDataSets()[0]->getRows()) {
                $row['__is_new'] = false;
            }else{
                $row['__is_new'] = true;
            }
            $this->crudService->save('consulta_tipo_materia_prima', array($row));
            $response->addDataSet(new DataSet('setor', array("sucesso" =>"sucesso")));
        }
    }
?>