<?php
namespace Teknisa\CDP\Modules\Producao\Controllers;

use DOMPDF;
use Doctrine\ORM\EntityManager;
use Teknisa\GER\Libraries\PHPMailer;
use Teknisa\CDP\Controllers\TeknisaCrud;
use Teknisa\GER\Controllers\CrudController;
use Teknisa\CDP\Modules\Producao\Services\cdp05010DescricaoTelaService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;

class cdp05010DescricaoTelaController extends TeknisaCrud{
    protected $dataSourceName = "descinspecao";
    protected $parameterBagColumns = array();
    protected $newCode;
    protected $environment;
    protected $service;
    
    public function __construct($crudService, ParameterBag $parameterBag, $newCode,$environment, $service){
        
        $this->novoCodigo = $newCode;
        $this->environment = $environment;
        $this->parameterBag = $parameterBag;
        $this->service = $service;
        parent::__construct($crudService, $parameterBag);
        
    }
    
    public function save(DTO\Request $request, DTO\Response $response) {
        $row = $request->getDataSet()->getRows()[0];
	    
	    try{
	        if(!$row['__is_new']) {
    	        $this->service->updateNaMao($row);
    	    } else {
    	        parent::save($request, $response);
    	    }
	    } catch(\Exception $e){
	        $response->setError(new DTO\Response\Error($e->getMessage()));
	    }
	}
    
    protected function processConditionValue($condition){
            return $condition['value'];
    }
    
    protected function populateParameterBag(FilterCriteria $filterCriteria){
    
        $conditions = array();
        foreach ($filterCriteria->getConditions() as $condition) {
            $columnName = $condition['columnName'];
            if (in_array($columnName, $this->parameterBagColumns)) {
                $this->parameterBag->set($columnName, $this->processConditionValue($condition));
            } else {
                $conditions[] = $condition;
            }
        }
        $newFilterCriteria = new FilterCriteria(
            $filterCriteria->getDataSourceName(),
            $conditions,
            $filterCriteria->getPage(),
            $filterCriteria->getPageSize()
        );
        return $newFilterCriteria;
        
    }
}

?>