<?php
namespace Teknisa\CDP\Modules\Producao\Factories;

use Doctrine\ORM\EntityManager;

class Cdp05000RoteiroProducaoFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection       = $entityManager->getConnection();
        $this->entityManager    = $entityManager;
    }

    public function selectProcessoFabricacao($CDFILIAL, $CDPRODUTO, $CDPROCFABRIC){
        try {
         
            $sql = "SELECT * FROM PROCFABRICA 
                        WHERE (CDFILIAL   = :CDFILIAL)
                        AND (CDPRODUTO    = :CDPRODUTO)
                        AND (CDPROCFABRIC = :CDPROCFABRIC)";

            $params = array(
                'CDFILIAL'=>$CDFILIAL,
                'CDPRODUTO'=>$CDPRODUTO,
                'CDPROCFABRIC'=>$CDPROCFABRIC
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
        }catch (\Exception $e) {
            throw $e;
        }
       
    }
    
    public function deleteProcessoFabricacao($CDFILIAL, $CDPRODUTO, $CDPROCFABRIC){
        try {
         
            $sql = "DELETE FROM PROCFABRICA 
                        WHERE (CDFILIAL   = :CDFILIAL)
                        AND (CDPRODUTO    = :CDPRODUTO)
                        AND (CDPROCFABRIC = :CDPROCFABRIC)";

            $params = array(
                'CDFILIAL'=>$CDFILIAL,
                'CDPRODUTO'=>$CDPRODUTO,
                'CDPROCFABRIC'=>$CDPROCFABRIC
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            
        }catch (\Exception $e) {
            throw $e;
        }
       
    }
    
    public function selectEtapaProd($CDFILIAL, $CDPRODUTO, $CDPROCFABRIC){
        try {
            $sql = "SELECT CDETAPAPROD FROM ETAFABRIC 
                        WHERE (CDFILIAL   = :CDFILIAL)
                        AND (CDPRODUTO    = :CDPRODUTO)
                        AND (CDPROCFABRIC = :CDPROCFABRIC)";

            $params = array(
                'CDFILIAL'=>$CDFILIAL,
                'CDPRODUTO'=>$CDPRODUTO,
                'CDPROCFABRIC'=>$CDPROCFABRIC
            );
            
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
        }catch (\Exception $e) {
            throw $e;
        }
       
    }

    public function deleteEtapaProd($CDFILIAL, $CDPRODUTO, $CDPROCFABRIC){
        try {
         
            $sql = "DELETE FROM ETAFABRIC 
                        WHERE (CDFILIAL   = :CDFILIAL)
                        AND (CDPRODUTO    = :CDPRODUTO)
                        AND (CDPROCFABRIC = :CDPROCFABRIC)";

            $params = array(
                'CDFILIAL'=>$CDFILIAL,
                'CDPRODUTO'=>$CDPRODUTO,
                'CDPROCFABRIC'=>$CDPROCFABRIC
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            
        }catch (\Exception $e) {
            throw $e;
        }
       
    }
    
    public function deleteEtapaProdPai($CDFILIAL, $CDPRODUTO, $CDPROCFABRIC, $CDETAPAPROD){
        try {
         
            $sql = "DELETE FROM ETAFABRIC 
                        WHERE (CDFILIAL   = :CDFILIAL)
                        AND (CDPRODUTO    = :CDPRODUTO)
                        AND (CDPROCFABRIC = :CDPROCFABRIC)
                        AND (CDETAPAPROD  = :CDETAPAPROD)";

            $params = array(
                'CDFILIAL'=>$CDFILIAL,
                'CDPRODUTO'=>$CDPRODUTO,
                'CDPROCFABRIC'=>$CDPROCFABRIC,
                'CDETAPAPROD'=>$CDETAPAPROD
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            
        }catch (\Exception $e) {
            throw $e;
        }
       
    }
    
    public function selectMateriaPrima($CDFILIAL, $CDPRODUTO, $CDETAPAPROD, $CDPROCFABRIC){
        try {
         
            $sql = "SELECT * FROM INSUMETAPA
                        WHERE (CDFILIAL   = :CDFILIAL)
                        AND (CDPRODUTO    = :CDPRODUTO)
                        AND (CDETAPAPROD  = :CDETAPAPROD)
                        AND (CDPROCFABRIC = :CDPROCFABRIC)";

            $params = array(
                'CDFILIAL'=>$CDFILIAL,
                'CDPRODUTO'=>$CDPRODUTO,
                'CDETAPAPROD'=>$CDETAPAPROD,
                'CDPROCFABRIC'=>$CDPROCFABRIC
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
        }catch (\Exception $e) {
            throw $e;
        }
       
    }

    public function deleteMateriaPrima($CDFILIAL, $CDPRODUTO, $CDETAPAPROD, $CDPROCFABRIC){
        try {
         
            $sql = "DELETE FROM INSUMETAPA
                        WHERE (CDFILIAL   = :CDFILIAL)
                        AND (CDPRODUTO    = :CDPRODUTO)
                        AND (CDETAPAPROD  = :CDETAPAPROD)
                        AND (CDPROCFABRIC = :CDPROCFABRIC)";

            $params = array(
                'CDFILIAL'=>$CDFILIAL,
                'CDPRODUTO'=>$CDPRODUTO,
                'CDETAPAPROD'=>$CDETAPAPROD,
                'CDPROCFABRIC'=>$CDPROCFABRIC
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            
        }catch (\Exception $e) {
            throw $e;
        }
       
    }
    
    public function selectAtividadesEtapa($CDFILIAL, $CDPRODUTO, $CDETAPAPROD, $CDPROCFABRIC){
        try {
         
            $sql = "SELECT NRINSPETAPA, CDINSPECAO FROM INSPETAPA 
                      WHERE (CDFILIAL   = :CDFILIAL)
                      AND (CDPRODUTO    = :CDPRODUTO)
                      AND (CDPROCFABRIC = :CDPROCFABRIC)
                      AND (CDETAPAPROD  = :CDETAPAPROD)";

            $params = array(
                'CDFILIAL'=>$CDFILIAL,
                'CDPRODUTO'=>$CDPRODUTO,
                'CDETAPAPROD'=>$CDETAPAPROD,
                'CDPROCFABRIC'=>$CDPROCFABRIC
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
        }catch (\Exception $e) {
            throw $e;
        }
       
    }
    
    public function deleteAtividadesEtapa($CDFILIAL, $CDPRODUTO, $CDETAPAPROD, $CDPROCFABRIC){
        try {
         
            $sql = "DELETE FROM INSPETAPA 
                        WHERE (CDFILIAL   = :CDFILIAL)
                        AND (CDPRODUTO    = :CDPRODUTO)
                        AND (CDPROCFABRIC = :CDPROCFABRIC)
                        AND (CDETAPAPROD  = :CDETAPAPROD)";

            $params = array(
                'CDFILIAL'=>$CDFILIAL,
                'CDPRODUTO'=>$CDPRODUTO,
                'CDETAPAPROD'=>$CDETAPAPROD,
                'CDPROCFABRIC'=>$CDPROCFABRIC
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            
        }catch (\Exception $e) {
            throw $e;
        }
       
    }
    
    public function deleteAtividadesEtapaPai($CDFILIAL, $CDPRODUTO, $CDETAPAPROD, $CDPROCFABRIC, $CDINSPECAO, $NRINSPETAPA){
        try {
         
            $sql = "DELETE FROM INSPETAPA 
                        WHERE (CDFILIAL   = :CDFILIAL)
                        AND (CDPRODUTO    = :CDPRODUTO)
                        AND (CDPROCFABRIC = :CDPROCFABRIC)
                        AND (CDETAPAPROD  = :CDETAPAPROD)
                        AND (NRINSPETAPA  = :NRINSPETAPA)
                        AND (CDINSPECAO  = :CDINSPECAO)";

            $params = array(
                'CDFILIAL'=>$CDFILIAL,
                'CDPRODUTO'=>$CDPRODUTO,
                'CDETAPAPROD'=>$CDETAPAPROD,
                'CDPROCFABRIC'=>$CDPROCFABRIC,
                'NRINSPETAPA'=>$NRINSPETAPA,
                'CDINSPECAO'=>$CDINSPECAO
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            
        }catch (\Exception $e) {
            throw $e;
        }
       
    }
    
    public function selectRecursoAtividade($CDFILIAL, $CDPRODUTO, $CDPROCFABRIC, $CDETAPAPROD, $CDINSPECAO, $NRINSPETAPA){
        try {
         
            $sql = "SELECT * FROM RECURETAPA
                        WHERE (CDFILIAL     = :CDFILIAL)
                        AND (CDPRODUTO      = :CDPRODUTO)
                        AND (CDPROCFABRIC   = :CDPROCFABRIC)
                        AND (CDETAPAPROD    = :CDETAPAPROD)
                        AND (CDINSPECAO     = :CDINSPECAO)
                        AND (NRINSPETAPA    = :NRINSPETAPA)";

            $params = array(
                'CDFILIAL'=>$CDFILIAL,
                'CDPRODUTO'=>$CDPRODUTO,
                'CDPROCFABRIC'=>$CDPROCFABRIC,
                'CDETAPAPROD'=>$CDETAPAPROD,
                'CDINSPECAO'=>$CDINSPECAO,
                'NRINSPETAPA'=>$NRINSPETAPA
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
        }catch (\Exception $e) {
            throw $e;
        }
       
    }
    
    public function deleteRecursoAtividade($CDFILIAL, $CDPRODUTO, $CDPROCFABRIC, $CDETAPAPROD, $CDINSPECAO, $NRINSPETAPA){
        try {
         
            $sql = "DELETE FROM RECURETAPA
                        WHERE (CDFILIAL     = :CDFILIAL)
                        AND (CDPRODUTO  = :CDPRODUTO)
                        AND (CDPROCFABRIC = :CDPROCFABRIC)
                        AND (CDETAPAPROD  = :CDETAPAPROD)
                        AND (CDINSPECAO   = :CDINSPECAO)
                        AND (NRINSPETAPA  = :NRINSPETAPA)";

            $params = array(
                'CDFILIAL'=>$CDFILIAL,
                'CDPRODUTO'=>$CDPRODUTO,
                'CDPROCFABRIC'=>$CDPROCFABRIC,
                'CDETAPAPROD'=>$CDETAPAPROD,
                'CDINSPECAO'=>$CDINSPECAO,
                'NRINSPETAPA'=>$NRINSPETAPA
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            
        }catch (\Exception $e) {
            throw $e;
        }
       
    }
    
}

