<?php

namespace Teknisa\CDP\Modules\Qualidade\Controllers;

use Doctrine\ORM\EntityManager;
use Teknisa\GER\Libraries\PHPMailer;
use Teknisa\CDP\Controllers\TeknisaCrud;
use Teknisa\GER\Controllers\CrudController;
use Teknisa\CDP\Modules\Qualidade\Services\QPR01800ItemChecagemService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;

class QPR01800ItemChecagemController extends TeknisaCrud {
        
        protected $dataSourceName = 'checklist';
        protected $dataSourceName_get = 'checklist';
        protected $item_questao_dataSourceName = 'questcheck';
        protected $item_questao_dataSourceName_get = 'questcheck_get';
        protected $dataSourceName_BOO = "respostaBoo";
        protected $dataSourceName_CAD = "respostaCad";
        protected $dataSourceName_VAL = "respostaVal";
        protected $dataSourceNameToSave = '';
        protected $dataSourceManager;
        protected $parameterBagColumns = array();
        protected $ItemChecagemService;
        protected $novoCodigo;
        protected $environment;
        
        public function __construct($crudService, ParameterBag $parameterBag, $ItemChecagemService,$novoCodigo,$environment){
            $this->novoCodigo = $novoCodigo;
            $this->environment = $environment;
            $this->parameterBag = $parameterBag;
            $this->ItemChecagemService = $ItemChecagemService;
            parent::__construct($crudService, $parameterBag);
        
        }
        
        //---------------------------Funções Item Checagem---------------------------------------//
        
        public function getItemChecagem (DTO\Request\Filter $request, DTO\Response $response){
            
            $this->dataSourceName = $this->dataSourceName_get;
            parent::find($request,$response);
            
        }
        
        public function setItemChecagem($request, DTO\Response $response){
            $this->dataSourceNameToSave = 'checklist';
            $dataSet = $request->getDataSet();
            $rows = $dataSet->getRows();
            
            try {
                parent::save($request,$response);
            } catch (\Exception $e) {
                $response->setError(new DTO\Response\Error($e->getMessage()));
            }
        }
        
        public function deleteItemChecagem ($request, DTO\Response $response){
            $dataSet = $request->getDataSet();
            $rows = $dataSet->getRows();
            $existeFilho = $this->ItemChecagemService->contQuest($rows);
            
            try {
                if($existeFilho[0]['QTDE'] == 0){
                    parent::delete($request,$response); 
                } else {
                    throw new \Exception("Item possui itens de questão. ");
                }
            } catch (\Exception $e) {
               throw $e;
            }
            
        }
        
        //---------------------------Funções Item Questão---------------------------------------//
        
        public function getItemQuestao (DTO\Request\Filter $request, DTO\Response $response){
            
            $this->dataSourceName = $this->item_questao_dataSourceName_get;
            parent::find($request,$response);
            
        }
        
        public function setItemQuestao($request, DTO\Response $response){
            $this->dataSourceNameToSave = 'questcheck';
            $dataSet = $request->getDataSet();
            $rows = $dataSet->getRows();
            
            try {
                if($rows[0]['NRQUESTCHECK']){
                    parent::save($request,$response);
                } else {
                    $geraCodigo = $this->ItemChecagemService->contQuest($rows);
                    $rows[0]['NRQUESTCHECK'] = $geraCodigo[0]['QTDE'] + 1;
                    $rows[0]['NRQUESTCHECK'] = strval($rows[0]['NRQUESTCHECK']);
                    while(strlen($rows[0]['NRQUESTCHECK']) < 3){
                        $rows[0]['NRQUESTCHECK'] = "0".$rows[0]['NRQUESTCHECK'];
                    }
                    parent::save($request,$response);
                }
            
            } catch (\Exception $e) {
                $response->setError(new DTO\Response\Error($e->getMessage()));
            }
        }
        
        public function deleteItemQuestao($request, DTO\Response $response){
            try {
                $this->dataSourceName = $this->item_questao_dataSourceName;
                parent::delete($request,$response);
            } catch (\Exception $e) {
                $response->setError(DTO\Response\Error($e->getMessage()));
            }
        }
        
        //---------------------------------Funções Telas Respostas------------------------------------//
        
        public function getRespBoo(DTO\Request\Filter $request, DTO\Response $response){
            $this->dataSourceName = $this->dataSourceName_BOO;
            parent::find($request,$response);
        }
        
        public function setRespBoo($request, DTO\Response $response){
            $this->dataSourceNameToSave = 'respostaBoo';
            $dataSet = $request->getDataSet();
            $rows = $dataSet->getRows();
            try {
                parent::save($request,$response);
            } catch (\Exception $e) {
                $response->setError(new DTO\Response\Error($e->getMessage()));
            }
        }
        
        public function deleteRespBoo($request, DTO\Response $response){
             try {
                $this->dataSourceName = $this->dataSourceName_BOO;
                parent::delete($request,$response);
            } catch (\Exception $e) {
                $response->setError(DTO\Response\Error($e->getMessage()));
            }
        }
        
         public function getRespVal(DTO\Request\Filter $request, DTO\Response $response){
            $this->dataSourceName = $this->dataSourceName_VAL;
            parent::find($request,$response);
        }
        
        public function setRespVal($request, DTO\Response $response){
            $this->dataSourceNameToSave = 'respostaVal';
            $dataSet = $request->getDataSet();
            $rows = $dataSet->getRows();
            try {
                parent::save($request,$response);
            } catch (\Exception $e) {
                $response->setError(new DTO\Response\Error($e->getMessage()));
            }
        }
        
        public function deleteRespVal($request, DTO\Response $response){
             try {
                $this->dataSourceName = $this->dataSourceName_VAL;
                parent::delete($request,$response);
            } catch (\Exception $e) {
                $response->setError(DTO\Response\Error($e->getMessage()));
            }
        }
        
        public function getRespCad(DTO\Request\Filter $request, DTO\Response $response){
            $this->dataSourceName = $this->dataSourceName_CAD;
            parent::find($request,$response);
        }
        
        public function setRespCad($request, DTO\Response $response){
            $this->dataSourceNameToSave = 'respostaCad';
            $dataSet = $request->getDataSet();
            $rows = $dataSet->getRows();
            try {
                parent::save($request,$response);
            } catch (\Exception $e) {
                $response->setError(new DTO\Response\Error($e->getMessage()));
            }
        }
        
        public function deleteRespCad($request, DTO\Response $response){
             try {
                $this->dataSourceName = $this->dataSourceName_CAD;
                parent::delete($request,$response);
            } catch (\Exception $e) {
                $response->setError(DTO\Response\Error($e->getMessage()));
            }
        }
        
        //-----------------------------------------------------------------------------------------------------//
        protected function processConditionValue($condition) 
        {
            return $condition['value'];
        }
    
        protected function populateParameterBag(FilterCriteria $filterCriteria) 
        {
    
            $conditions = array();
            foreach ($filterCriteria->getConditions() as $condition) {
                $columnName = $condition['columnName'];
                if (in_array($columnName, $this->parameterBagColumns)) {
                    $this->parameterBag->set($columnName, $this->processConditionValue($condition));
                } else {
                    $conditions[] = $condition;
                }
            }
            $newFilterCriteria = new FilterCriteria(
                $filterCriteria->getDataSourceName(),
                $conditions,
                $filterCriteria->getPage(),
                $filterCriteria->getPageSize()
            );
            return $newFilterCriteria;
        }
    }
?>