/*
@C:\WEB_635\SQL\END_CONV\ORACLE\CLIENTES\CLO\0010_CLOSTPO_USR_ATUALIZA_POSI.SQL

 DESCRIO:
 PROCEDURE PARA GERAO DO SALDO DE ESTOQUE PARA UTILIZAO CONFOMRE API

 RAISE_APPLICATION_ERROR(-20501, '' , TRUE);
*/


CREATE OR REPLACE PROCEDURE USR_ATUALIZAPOSIESTOQ
IS
  V_QTRESERVA     FLOAT;
  V_CDTIPCUSTEST  VARCHAR2(2);
BEGIN
   V_QTRESERVA := 0;
   DELETE FROM USR_POSIESTOQ;

   INSERT INTO USR_POSIESTOQ (CDPRODUTO, CDPRODINTE, QTESTOQDIA, VRESTOQDIA, VRESTOQBRUT,
                              VRMEDIO, VRMEDIOBRUT, NRORG, NMPRODUTO, SGUNIDADE,
                              CDPRODESTO, CDFILIAL,  CDALMOXARIFE, CDLOCALESTOQ,
                              DSALMOXARIFE, DSLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE,
                              CDARVPROD, VRCUSTOPROD, VRTOTALPROD)
      SELECT DISTINCT B.CDPRODUTO,
                      A.CDPRODINTE,
                      QTESTOQDIA,
                      VRESTOQDIA,
                      VRESTOQBRUT,
                      (VRESTOQDIA /QTESTOQDIA) AS VRMEDIO,
                      (VRESTOQBRUT/QTESTOQDIA) AS VRMEDIOBRUT,
                      B.NRORG,
                      A.NMPRODUTO,
                      A.SGUNIDADE,
                      A.CDPRODESTO,
                      B.CDFILIAL,
                      B.CDALMOXARIFE,
                      B.CDLOCALESTOQ,
                      AL.DSALMOXARIFE,
                      LE.DSLOCALESTOQ,
                      B.NRLOTEESTQ,
                      B.NRSUBLOTE,
                      A.CDARVPROD,
                      VRCUSTOPROD,
                      VRCUSTOPROD * QTESTOQDIA AS VRTOTALPROD
        FROM ALMOXARIFADO AL,
             LOCALESTOQUE LE,
             (SELECT DISTINCT D.CDPRODUTO,
                              D.NMPRODUTO,
                              D.SGUNIDADE,
                              D.CDARVPROD,
                              D.CDPRODESTO,
                              D.CDPRODINTE,
                              D.NRORG
                FROM PRODUTO D,
                     PRODUTO N
               WHERE D.NRORG = N.NRORG) A,
             (SELECT CDFILIAL,
                     CDALMOXARIFE,
                     CDLOCALESTOQ,
                     NRLOTEESTQ,
                     QTESTOQDIA,
                     CDPRODUTO,
                     NRSUBLOTE,
                     DTPOSIESTQ,
                     VRESTOQBRUT,
                     VRESTOQDIA,
                     NRORG,
                     NVL(CUSTO_PRODUTO_LCEST(POE.CDFILIAL, CDPRODUTO, 3, TO_DATE(SYSDATE)-1, SYSDATE, POE.CDALMOXARIFE, POE.CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE),0) AS VRCUSTOPROD
                FROM POSESTDIA POE
               WHERE (ABS(QTESTOQDIA) > 0.00001))B
       WHERE (B.CDPRODUTO     = A.CDPRODUTO)
         AND (A.CDPRODUTO     = A.CDPRODESTO)
         AND (B.NRORG         = A.NRORG)
         AND (AL.CDFILIAL     = B.CDFILIAL)
         AND (AL.CDALMOXARIFE = B.CDALMOXARIFE)
         AND (AL.NRORG        = B.NRORG)
         AND (LE.CDFILIAL     = B.CDFILIAL)
         AND (LE.NRORG        = B.NRORG)
         AND (LE.CDALMOXARIFE = B.CDALMOXARIFE)
         AND (LE.CDLOCALESTOQ = B.CDLOCALESTOQ)
         AND (B.DTPOSIESTQ    =  (SELECT MAX(P.DTPOSIESTQ)
                                    FROM POSESTDIA P
                                   WHERE P.CDPRODUTO   = B.CDPRODUTO
                                     AND P.NRORG       = B.NRORG
                                     AND P.NRLOTEESTQ  = B.NRLOTEESTQ
                                     AND P.NRSUBLOTE   = B.NRSUBLOTE
                                     AND P.DTPOSIESTQ <= SYSDATE))
       ORDER BY A.NMPRODUTO;
   COMMIT;

   FOR C_POSICAO IN (SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                       FROM USR_POSIESTOQ)
   LOOP
      BEGIN
         SELECT SUM(A.QTRESERVA)
           INTO V_QTRESERVA
           FROM (SELECT QTRESPRODARR as QTRESERVA
                   FROM RESERPRODPED
                  WHERE CDFILIAL     = C_POSICAO.CDFILIAL
                    AND CDALMOXARIFE = C_POSICAO.CDALMOXARIFE
                    AND CDLOCALESTOQ = C_POSICAO.CDLOCALESTOQ
                    AND NRLOTEESTQ   = C_POSICAO.NRLOTEESTQ
                    AND NRSUBLOTE    = C_POSICAO.NRSUBLOTE
                    AND CDPRODUTO    = C_POSICAO.CDPRODUTO
                  UNION ALL
                 SELECT QTRESERVESTOL AS QTRESERVA
                   FROM RESERVAPEDEXOL RS, RELACPRODOL RL
                  WHERE RS.CDPRODUTO   = RL.CDPRARVORIG
                    AND RS.CDMARCA     = RL.CDMARCA
                    AND RS.CDFILRESOL  = C_POSICAO.CDFILIAL
                    AND RL.CDPRODARVOL = C_POSICAO.CDPRODUTO) A;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_QTRESERVA := 0;
      END;

      IF V_QTRESERVA > 0 THEN
         UPDATE USR_POSIESTOQ
            SET QTESTOQDIA  = (QTESTOQDIA - V_QTRESERVA),
                VRESTOQDIA  = ROUND(VRESTOQDIA - (V_QTRESERVA * (VRESTOQDIA / QTESTOQDIA)),5),
                VRESTOQBRUT = ROUND(VRESTOQBRUT - (V_QTRESERVA * (VRESTOQBRUT / QTESTOQDIA)),5),
                VRMEDIO     = ROUND((VRESTOQDIA - (V_QTRESERVA * (VRESTOQDIA / QTESTOQDIA))) / DECODE((QTESTOQDIA - V_QTRESERVA), 0, 1, (QTESTOQDIA - V_QTRESERVA)),5),
                VRMEDIOBRUT = ROUND((VRESTOQBRUT - (V_QTRESERVA * (VRESTOQBRUT / QTESTOQDIA))) / DECODE((QTESTOQDIA - V_QTRESERVA), 0, 1, (QTESTOQDIA - V_QTRESERVA)),5),
                VRTOTALPROD = VRCUSTOPROD * (QTESTOQDIA - V_QTRESERVA)
          WHERE CDFILIAL     = C_POSICAO.CDFILIAL
            AND CDALMOXARIFE = C_POSICAO.CDALMOXARIFE
            AND CDLOCALESTOQ = C_POSICAO.CDLOCALESTOQ
            AND NRLOTEESTQ   = C_POSICAO.NRLOTEESTQ
            AND NRSUBLOTE    = C_POSICAO.NRSUBLOTE
            AND CDPRODUTO    = C_POSICAO.CDPRODUTO;
      END IF;         
   END LOOP;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_ATUALIZAPOSIESTOQ','6.35.027'); END;
/
